#ifndef EFL_GENERATED_EVAS_COMMON_INTERFACE_HH
#define EFL_GENERATED_EVAS_COMMON_INTERFACE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_common_interface.eo.h"
}


namespace evas {

struct common_interface
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit common_interface(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit common_interface(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   common_interface(common_interface const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~common_interface() {}

   /// @brief No description supplied by the EAPI.
   ///
   /// @param ret 
   ///
   Evas * evas_get() const
   {
      Evas * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::evas_common_evas_get());
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(EVAS_COMMON_INTERFACE_INTERFACE);
   }

private:
};
} 

template <typename T>
Evas * evas_common_interface_evas_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->evas_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< evas::common_interface >
{
   template <typename T>
   struct type
   {
      virtual Evas * evas_get()
      {
         Evas * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::evas_common_evas_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< evas::common_interface >
{
   static const int value = 1;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<evas::common_interface>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::evas_common_interface_evas_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::evas_common_evas_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< evas::common_interface >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::common_interface, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< evas::common_interface>
{
   template <typename U>
   struct type
   {
      operator evas::common_interface() const
      {
         return evas::common_interface(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      Evas * evas_get()
      {
         Evas * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::evas_common_evas_get());
            return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<evas::common_interface>)
{
   return (EVAS_COMMON_INTERFACE_INTERFACE);
}

} } }
#endif // EFL_GENERATED_EVAS_COMMON_INTERFACE_HH

